package com.docus.sw.fenpan;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

/**
 * 卷
 */
@Getter
@AllArgsConstructor
public class Roll {

    private String name;

    private List<Pieces> piecesList;

    private String absolutePath;

    public Integer getSize(){
        Integer size = 0;
        for(Pieces pieces:piecesList){
            size+= pieces.getSize();
        }
        return size;
    }


    public Roll(String name, String absolutePath) {
        this.name = name;
        this.absolutePath = absolutePath;
        piecesList = new ArrayList<>();
    }

    public void putPieces(Pieces pieces){
        piecesList.add(pieces);
    }

    public void putAll(List<Pieces> piecesList){
        this.piecesList.addAll(piecesList);
    }



}
